#ifndef _CTM_H_
#define _CTM_H_

/* type declarations */
typedef unsigned long DWORD;
typedef unsigned int WORD;

#define FALSE 0
#define TRUE (!FALSE)

#define ctmAvgFilterOn 'T'
#define ctmAvgFilterOff 'W'
#define ctmHysFilterOn 'P'
#define ctmHysFilterOff 'O'

#define BUFFERSIZE 9

#define D32RealSeg(P)   ((((DWORD) (P)) >> 4) & 0xFFFF)
#define D32RealOff(P)   (((DWORD) (P)) & 0x000F)
#define HIBYTE(p) (((unsigned long) p) >> 16)
#define LOWBYTE(p) (((unsigned long) p) & 0xFFFF)


#define PIC_IMR    0x21   // pic's interrupt mask reg.
#define PIC_ICR    0x20   // pic's interupt control reg.
#define SERIAL_GP02        8     // enable interrupt

extern const int UARTS[];
extern const int IRQS[];
enum parities {NONE, EVEN, ODD,MARK,SPACE};

#define IER                                 0x01 
#define IIR                                 0x02
#define FCR                                 0x02 
#define LCR                                 0x03 
#define LCR_WORD_LENGTH_MASK                0x03
#define LCR_WORD_0                          0x01 
#define LCR_WORD_1                          0x02 
#define LCR_STOP_BITS                       0x04
#define LCR_PARITY_MASK                     0x38
#define LCR_PARITY_ENABLE                   0x08
#define LCR_EVEN_PARITY_SELECT              0x10
#define LCR_STICK_PARITY                    0x20
#define LCR_DLAB                            0x80 
#define MCR                                 0x04
#define LSR                                 0x05
#define DLL                                 0x00
#define DLH                                 0x01

/* FUNCTION PROTOTYPES */ 

extern int port_exist(int comport);
extern int get_settings(int comport, int *oldbaud, int *oldbits, int *oldparity, 
                  int *oldstopbits);
extern int set_port(int comport, int baud, int bits, int parity, int stopbits);
extern int startISR(int comport);
extern int closeISR (int comport);
extern int write_byte (int comport, unsigned int CTMByte);
extern int handshakeCTM (int comport);
extern int detectCTM(int *port);
extern int initCTM(int comport);
extern void setCTM(int comport, unsigned int ch);
extern void closeCTM (int comport);

typedef struct QUEUEDATA
  {
  short jmp;
  long pmode;
  long rmode;
  char serial_char;
  short serial_end;
  short comport;
  short irq;
  long hdrfail;
  long chkfail;
  short yaw;
  short pitch;
  short roll;
  char buffer[9];
  } QUEUEDATA;

extern QUEUEDATA * qdata;
     
#endif // #ifndef

