#ifndef __CTM
#define __CTM

#define FALSE 0
#define TRUE !(FALSE)

#define ctmAvgFilterOn 'T'
#define ctmAvgFilterOff 'W'
#define ctmHysFilterOn 'P'
#define ctmHysFilterOff 'O'

#define BUFFSIZE 1024

#define PIC_IMR    0x21   // pic's interrupt mask reg.
#define PIC_ICR    0x20   // pic's interupt control reg.
#define INT_SERIAL_PORT_0    0x0C  // port 0 interrupt com 1 & 3
#define INT_SERIAL_PORT_1    0x0B  // port 1 interrupt com 2 & 4
#define SERIAL_GP02        8     // enable interrupt

const int UARTS[]={0,0x3f8,0x2f8};
enum parities {NONE, EVEN, ODD,MARK,SPACE};

const int IER                                 = 0x01; 
const int IIR                                 = 0x02; 
const int FCR                                 = 0x02; 
const int LCR                                 = 0x03; 
const int LCR_WORD_LENGTH_MASK                = 0x03;
const int LCR_WORD_0                          = 0x01; 
const int LCR_WORD_1                          = 0x02; 
const int LCR_STOP_BITS                       = 0x04;
const int LCR_PARITY_MASK                     = 0x38;
const int LCR_PARITY_ENABLE                   = 0x08;
const int LCR_EVEN_PARITY_SELECT              = 0x10;
const int LCR_STICK_PARITY                    = 0x20;
const int LCR_DLAB                            = 0x80; 
const int MCR                                 = 0x04; 
const int LSR                                 = 0x05; 
const int DLL                                 = 0x00;
const int DLH                                 = 0x01;

/* FUNCTION PROTOTYPES */ 

int port_exist(int comport);
int get_settings(int comport, int *oldbaud, int *oldbits, int *oldparity, 
                  int *oldstopbits);
int set_port(int comport, int baud, int bits, int parity, int stopbits);
void startISR(int comport);
void closeISR (int comport);
int read_byte (unsigned int * ch);
int write_byte (int comport, unsigned int CTMByte);
int handshakeCTM (int comport);
void purge_in();
int readCTM(int comport, float *yaw, float *pitch, float *roll);
int detectCTM(int *port);
int initCTM(int comport);
void setCTM(int comport, unsigned int ch);
int versionCTM(int comport, int *ver, int *revi, unsigned int *subrevi);
void closeCTM (int comport);

#endif // #ifndef

